declare global {
  interface Window { tinymce: any; }
}

const tinymce = window.tinymce || {};

const mobilePluginInit = () => {

  tinymce.on('SetupEditor', e => {
    if(!(tinymce.settings.mobile && (tinymce.Env.android || tinymce.Env.iOS))) {
      return;
    }

    const editor = e.editor;
    
    const mobileReady = [];
    const nativePlugin = ['lists', 'autolink', 'autosave'];
    const pluginList = tinymce.util.Tools.explode(tinymce.settings.mobile.plugins, ' ');
    pluginList.forEach(p => {
      if(!nativePlugin.includes(p)) {
        mobileReady.push(p);
      }
    })

    mobileReady.forEach(name => {
      const Plugin = tinymce.PluginManager.get(name);
      if(!Plugin) return;
      const pluginUrl = tinymce.PluginManager.urls[name] || editor.documentBaseUrl.replace(/\/$/, '');
      const plugin = tinymce.trim(name);
      const pluginInstance = new Plugin(editor, pluginUrl, tinymce.$);

      editor.plugins[plugin] = pluginInstance;
    
      if (pluginInstance.init) {
        pluginInstance.init(editor, pluginUrl);
      }
    })
  });
}

export default mobilePluginInit;