declare class Uploader {
  constructor(editor: any, upload_url?: string, upload_handler?: Function)

  initDom(): void

  getImageItemNode(options: Object, uploadData: any): any

  /**
   * options에 따라 uploadForUrl 혹은 uploadForFile을 호출한다.
   * - url: uploadForUrl
   * - file: uploadForFile
   *
   * @param options
   */
  execUploadForOption(options: Object): void

  /**
   * 외부 url의 파일을 업로드한다.
   * - url: 외부 url
   * - targetId: UI에 미리 그려둔 업로드 파일의 element ID
   * - callback: 업로드 후 호출
   *
   * @param options
   */
  uploadForUrl(options: Object): void

  addProgressBar(options: Object): void

  removeProgressBar(options: Object): void

  resetUpload(options: Object): void

  /**
   * 사용자의 로컬 파일에서 업로드한다.
   * - file: 업로드할 파일 object
   * - targetId: UI에 미리 그려둔 업로드 파일의 element ID
   * - callback: 업로드 후 호출
   *
   * @param options
   */
  uploadForFile(options: Object): void
}

export default Uploader
