/*
 * 이미지 첨부 파일 열기
 */
const openFile = options => {
  let fileInput = document.getElementById('openFile') || createFileInput()
  return new Promise(resolve => {
    fileInput.onchange = e => {
      resolve(Array.prototype.slice.call(e.target.files))
      fileInput.value = null
    }
    fileInput.multiple = options && options.multiple
    fileInput.accept = options && options.accept
    fileInput.click()
  })
}

const createFileInput = () => {
  let fileInput
  fileInput = document.createElement('input')
  fileInput.id = 'openFile'
  fileInput.type = 'file'
  fileInput.style.position = 'fixed'
  fileInput.style.left = 0
  fileInput.style.top = 0
  fileInput.style.opacity = 0.001
  document.body.appendChild(fileInput)
  return fileInput
}

export default openFile
