const attachFile = (editor, file) => {
  const attach = file => {
    const fileId =
      'file_' +
      new Date().valueOf() +
      Math.random()
        .toFixed(16)
        .substring(2)

    const wrapElement = editor.dom.create('figure', { 'data-ke-type': 'file', contenteditable: 'false' })
    wrapElement.innerHTML = `<a id="${fileId}" href="#"><div class="image"></div><div class="desc"><p class="filename"></p><p class="size"></p></div><button class="cancel" type="button">취소</button></a>`

    editor.undoManager.transact(() => {
      editor.insertContent(wrapElement.outerHTML)
    })
    return fileId
  }

  return attach(file)
}

export default attachFile
