import openFile from 'src/lib/openFile'

type Itme = {
  src: String
}

class Layer {
  editor: any
  window: any
  windowId: string
  items: Itme[]
  editImageSlide: any
  draggedElem: any
  isUploading: boolean = false
  constructor(editor, windowId) {
    this.editor = editor
    this.draggedElem
    this.windowId = windowId
  }

  show(slideshowObject = null) {
    this.items = []

    if (slideshowObject && slideshowObject.dataset.keType == 'imageSlide') {
      this.editImageSlide = slideshowObject
    } else {
      this.editImageSlide = null
    }

    this.window = this.editor.windowManager.open({
      title: '슬라이드쇼',
      id: this.windowId,
      items: [
        {
          type: 'container',
          html: `<div class="container_imageSlide">
          <div class="body">
            <div class="wrap_addImage">
              <span class="addImageIcon"></span>
              <button class="addImageButton" type="button">이미지 추가</button>
            </div>
          </div>
        </div>`,
        },
      ],
      buttons: [
        {
          text: '취소',
          onClick: () => {
            this.hide()
          },
        },
        {
          text: '확인',
          subtype: 'primary',
          onClick: () => {
            this.appendSlide()
          },
        },
      ],
    })
    this.toggleSubmitButtonActivate()
    this.addEvent()
  }

  addEvent() {
    if (this.window.$el[0]) {
      const $ = this.window.$
      const windowElem = this.window.$el[0]
      $('#mce-modal-block').on('click', this.hide.bind(this))
      $('.cancel', windowElem).on('click', this.hide.bind(this))
      $('.submit', windowElem).on('click', this.appendSlide.bind(this))
      $('.wrap_addImage').on('click', this.addImage.bind(this))
      $('.body', windowElem).on('mouseover', this.imageMouseOver.bind(this))
      $('.body', windowElem).on('mouseout', this.imageMouseOut.bind(this))
      $('.body', windowElem).on('dragstart', this.imageDragStart.bind(this))
      $('.body', windowElem).on('dragend', this.imageDragEnd.bind(this))
      $('.body', windowElem).on('dragover', this.imageDragOver.bind(this))
      $('.body', windowElem).on('dragleave', this.imageDragLeave.bind(this))
      $('.body', windowElem).on('drop', this.imageDrop.bind(this))
    }
  }

  keydownHandler(e) {
    if (e.keyCode == 27) {
      this.hide()
    }
  }

  hide() {
    if (this.window) {
      this.window.close()
    }
    this.window.$(window).off('keydown')
  }

  appendImage(imageObj) {
    const selectedClass = this.editImageSlide ? ' select' : ''
    const elemString = `<div class="wrap_item${selectedClass}" data-src="${imageObj.data.url}" draggable="true">
      <div class="wrap_image" style="background-image:url(${imageObj.data.url})"></div>
      <button type="button" class="removeImageButton"></button>
    </div>`
    const imageNode = this.editor.$(elemString)
    this.window.$('.removeImageButton', imageNode[0]).on('click', this.removeImage.bind(this))
    this.window.$('.body', this.window.$el[0]).prepend(imageNode)

    const windowElem = this.window.$el[0]
    const $item = this.editor.$('.wrap_item', windowElem)
    if ($item.length > 1) {
      this.toggleSubmitButtonActivate()
    }
  }

  appendImageShow(imageObj) {
    const $imageWrap = this.window.$('#' + imageObj.options.targetId, this.window.$el[0])
    $imageWrap.attr('style', `background-image:url(${imageObj.data.url})`)
    $imageWrap.parent().attr('data-src', imageObj.data.url)

    const windowElem = this.window.$el[0]
    const $item = this.editor.$('.wrap_item', windowElem)
    if ($item.length > 1) {
      this.toggleSubmitButtonActivate()
    }
  }

  appendImageWrap(imageId: string) {
    const elemString = `<div class="wrap_item" data-src="" draggable="true">
      <div id="${imageId}" class="wrap_image"></div>
      <button type="button" class="removeImageButton"></button>
    </div>`
    const imageNode = this.editor.$(elemString)
    this.window.$('.removeImageButton', imageNode[0]).on('click', this.removeImage.bind(this))
    this.window.$('.body', this.window.$el[0]).prepend(imageNode)
  }

  private appendSlide() {
    const $ = this.window.$
    const windowElem = this.window.$el[0]
    const items = this.items
    let src: String

    if (this.isUploading) {
      alert('이미지 업로드 중입니다.')
      return false
    }

    $('.wrap_item', windowElem).each(function(index, elem) {
      src = elem.dataset.src
      items.push({
        src: src,
      })
    })

    if (items.length == 0) {
      alert('이미지를 첨부해 주세요.')
      return false
    }

    const $imageSlideItem = $(
      `<figure contenteditable="false" data-ke-type="imageSlide" data-ke-style="alignCenter"></figure>`
    )
    $imageSlideItem.html(`<img width="480" src="${items[0].src}" />`)
    $imageSlideItem.attr('data-images', JSON.stringify(items))
    let slideMarkString = '<div data-ke-style="mark">'
    for (let i = 0, l = items.length; i < l; i++) {
      slideMarkString += '<span>&nbsp;</span>'
    }
    slideMarkString += '</div>'
    $imageSlideItem.append(this.editor.$(slideMarkString))

    if (this.editImageSlide) {
      $(this.editImageSlide).replaceWith($imageSlideItem)
      this.editor.selection.select($imageSlideItem[0])
    } else {
      this.editor.insertContent($imageSlideItem[0].outerHTML)
    }
    this.hide()
  }

  private imageDragStart(e: DragEvent) {
    const target: any = e.target
    this.draggedElem = target
    target.style.opacity = 0.5
  }

  private imageDragEnd(e: DragEvent) {
    const target: any = e.target
    target.style.opacity = ''
  }

  private imageDragOver(e: DragEvent) {
    e.preventDefault()
    const target: any = e.target
    if (target.className !== 'wrap_image' || this.draggedElem == target.parentNode) {
      return false
    }
    const halfWidth = target.clientWidth / 2
    const offsetX = e.offsetX
    if (halfWidth > offsetX) {
      const parentTarget = target.parentNode
      parentTarget.classList.remove('append-right')
      parentTarget.classList.add('append-left')
    } else {
      const parentTarget = target.parentNode
      parentTarget.classList.remove('append-left')
      parentTarget.classList.add('append-right')
    }
  }

  private imageDragLeave(e: DragEvent) {
    e.preventDefault()
    const target: any = e.target
    if (target.className === 'wrap_image') {
      target.parentNode.classList.remove('append-left')
      target.parentNode.classList.remove('append-right')
    }
  }

  private imageDrop(e) {
    e.preventDefault()
    e.stopPropagation()
    const target: any = e.target
    if (target.className !== 'wrap_image') {
      return false
    }
    const imageWrapElem = target.parentNode
    if (imageWrapElem.classList.contains('append-left')) {
      imageWrapElem.classList.remove('append-left')
      this.editor.$(imageWrapElem).before(this.draggedElem)
    } else if (imageWrapElem.classList.contains('append-right')) {
      imageWrapElem.classList.remove('append-right')
      this.editor.$(imageWrapElem).after(this.draggedElem)
    }
  }

  private imageMouseOver(e: MouseEvent) {
    const target: any = e.target
    if (target.className == 'wrap_image' || target.className == 'removeImageButton') {
      const imageWrap = target.parentNode
      imageWrap.classList.add('hover')
    }
  }

  private imageMouseOut(e: MouseEvent) {
    const target: any = e.target
    if (target.className == 'wrap_image' || target.className == 'removeImageButton') {
      const imageWrap = target.parentNode
      imageWrap.classList.remove('hover')
    }
  }

  private addImage() {
    const windowElem = this.window.$el[0]
    const $item = this.editor.$('.wrap_item', windowElem)
    openFile({ multiple: true, accept: 'image/*' }).then(files => {
      if (files.length + $item.length > 15) {
        alert('이미지 슬라이드 이미지는 15개까지 가능합니다.')
        return false
      } else {
        this.editor.execCommand('AttachSlideshowImage', files)
      }
    })
  }

  private removeImage(e) {
    const target = e.target
    const itemElem = target.parentNode
    itemElem.parentNode.removeChild(itemElem)
    this.toggleSubmitButtonActivate()
  }

  private toggleSubmitButtonActivate() {
    const windowElem = this.window.$el[0]
    const $item = this.editor.$('.wrap_item', windowElem)
    const $submitButton = this.editor.$('.submit', windowElem)
    if ($item.length < 2) {
      $submitButton.attr('disabled', 'disabled')
    } else {
      $submitButton.attr('disabled', null)
    }
  }

  setIsUploading(status: boolean) {
    this.isUploading = status
  }
}

export default Layer
