class Panel {
  editor: any
  panel: any
  widthInput: HTMLInputElement
  contentSize: number
  widthInputId: String
  $widthInput: any
  MinWidth: Number = 480
  constructor(editor: any, widthInputId: String) {
    this.editor = editor
    this.widthInputId = widthInputId
  }

  init(panel: any) {
    this.panel = panel
    this.$widthInput = panel.$('#' + this.widthInputId, panel.$el[0])
    this.contentSize = this.editor.getBody().offsetWidth
    if (this.editor.settings.autoresize_overflow_padding) {
      this.contentSize -= this.editor.settings.autoresize_overflow_padding * 2
    }
    this.editor.on('ObjectResizeStart', function() {
      panel.hide()
    })
  }

  getImageElem(): HTMLImageElement {
    const selectNode: HTMLImageElement = this.editor.selection.getNode()
    if (selectNode.nodeName === 'IMG') {
      return selectNode
    } else {
      const $selectNode: any = this.editor.$(selectNode)
      const $figureClosestNode = $selectNode.closest('figure')
      if ($figureClosestNode && $figureClosestNode[0]) {
        return $figureClosestNode[0].firstElementChild
      }
    }
  }

  updateMaxSize() {
    this.updateImageWidth(this.contentSize)
    this.panel.hide()
  }

  updateImageWidth(width) {
    width = parseInt(width)
    if (!width) {
      return false
    }
    const slideItem = this.getImageElem()
    width = width > this.contentSize ? this.contentSize : width
    width = width < this.MinWidth ? this.MinWidth : width
    slideItem.setAttribute('width', width)
    window.setTimeout(() => {
      this.editor.execCommand('mceAutoResize')
    })
  }

  show() {
    const imageElem = this.getImageElem()
    if (imageElem) {
      let width: number = Number(imageElem.getAttribute('width'))
      if (width === 0) {
        width = Number(imageElem.offsetWidth)
      }
      this.$widthInput[0].value = width > this.contentSize ? this.contentSize : width
    }
  }
}

export default Panel
