/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 */

interface CharmapSetting {
  items?: any,
  preview?: boolean,
  append?: any
}

const _getSetting = function(editor): CharmapSetting {
  const setting = editor.settings.kCharmap
  if (!setting) {
    return {
      items: null,
      preview: false,
      append: null,
    }
  } else {
    return {
      items: setting.items,
      preview: setting.preview,
      append: setting.append
    }
  }
};

const getCharMap = function (editor): any {
  return _getSetting(editor).items;
};

const getCharMapAppend = function (editor): any {
  return _getSetting(editor).append;
};

const getPreview = function(editor): boolean {
  return _getSetting(editor).preview;
}

export default {
  getCharMap,
  getCharMapAppend,
  getPreview
};
