/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 */

import Events from '../api/Events'

const customInsertNodeNameArry: String[] = ['FIGCAPTION', 'TD', 'LI', 'BLOCKQUOTE']

const insertChar = function(editor, chr) {
  const selectNode = editor.selection.getNode()
  const evtChr = Events.fireInsertCustomChar(editor, chr).chr
  if (customInsertNodeNameArry.includes(selectNode.nodeName)) {
    const selection = editor.selection
    const range = editor.selection.getRng()
    range.deleteContents()
    const node = editor.getWin().document.createTextNode(evtChr)
    range.insertNode(node)
    range.setStart(node, 1)
    range.setEnd(node, 1)
    selection.setCursorLocation(node)
    selection.getSel().removeAllRanges()
    selection.getSel().addRange(range)
  } else {
    editor.execCommand('mceInsertContent', false, evtChr)
  }
}

export default {
  insertChar,
}
