import { Table } from '../interface/ItemAttribute'
import cssConvert from '../util/CSSToObject'

enum TableChildType {
  Tbody = 'body',
  Th = 'heading',
  Tr = 'row',
  Td = 'data',
}

const register = (treeObject: Element | any, itemAttribute: Table) => {
  const nodeName = treeObject.name
  const style: any = cssConvert(treeObject.attributes.map.style)
  if (nodeName === 'table') {
    const keStyle = treeObject.attributes.map['data-ke-style']
    keStyle && (itemAttribute.keStyle = keStyle)
    style.width && (itemAttribute.width = style.width)
    style.height && (itemAttribute.height = style.height)
  } else if (nodeName === 'tbody') {
    itemAttribute.tableChildType = TableChildType.Tbody
  } else if (nodeName === 'tr') {
    itemAttribute.tableChildType = TableChildType.Tr
    style.height && (itemAttribute.height = style.height)
  } else if (nodeName === 'th') {
    itemAttribute.tableChildType = TableChildType.Th
    style.width && (itemAttribute.width = style.width)
  } else if (nodeName === 'td') {
    itemAttribute.tableChildType = TableChildType.Td
    itemAttribute.width = style.width
  }
}

export default {
  register,
}
