import { Text } from '../interface/ItemAttribute'
import cssConvert from '../util/CSSToObject'

const register = (treeObject: Element | any, itemAttribute: Text) => {
  const nodeName = treeObject.name
  const mapStyleString = nodeName === '#text' ? undefined : treeObject.attributes.map.style
  const style: any = cssConvert(mapStyleString)
  style.color && (itemAttribute.textColor = style.color)

  if (['b', 'strong'].includes(nodeName)) {
    itemAttribute.textStyle = 'bold'
  } else if (['em', 'i'].includes(nodeName)) {
    itemAttribute.textStyle = 'italic'
  } else if (['s', 'del'].includes(nodeName)) {
    itemAttribute.textStyle = 'lineThrough'
  } else if (nodeName == 'span') {
    style['text-decoration'] && (itemAttribute.textStyle = style['text-decoration'])
  } else if (nodeName === '#text') {
    treeObject.value && (itemAttribute.text = treeObject.value)
  }
}

export default {
  register,
}
