class AlignFloatAction {
  editor: any
  constructor(editor) {
    this.editor = editor
  }

  private getFigureNode() {
    let selectionNode = this.editor.selection.getNode()
    const $figureNode = this.editor.$(selectionNode).closest('figure[data-ke-type]')
    if ($figureNode && $figureNode[0]) {
      return $figureNode
    } else {
      return null
    }
  }

  private alignFloat(alignFloatValue) {
    const $imageFigure = this.getFigureNode()
    const bodyWidth = this.editor.getBody().offsetWidth
    if ($imageFigure) {
      const keStyle = $imageFigure.attr('data-ke-style')
      const $imageElem = this.editor.$('img', $imageFigure[0])
      if (keStyle !== alignFloatValue) {
        $imageFigure.attr('data-ke-style', alignFloatValue)
      }
      const $figcaption = this.editor.$('figcaption', $imageFigure[0])
      switch (alignFloatValue) {
        case 'alignCenter':
          $figcaption.css('display', '')
          break
        case 'alignLeft':
        case 'alignRight':
          $imageElem.attr('width', Math.round(bodyWidth * 0.75))
          $imageElem.attr('height', null)
          $figcaption.css('display', '')
          break
        case 'floatLeft':
        case 'floatRight':
          $imageElem.attr('width', Math.round(bodyWidth * 0.4))
          $imageElem.attr('height', null)
          $figcaption.css('display', 'none')
          break
      }
      this.editor.selection.controlSelection.updateResizeRect({ type: null })
      if ($imageFigure.attr('data-ke-type') === 'image') {
        this.editor.execCommand('updateRepresentButton', $imageElem[0])
      }
      this.editor.selection.getNode().click()
    }
  }

  register(action, actionCommand) {
    this.editor.addCommand(actionCommand, this.alignFloat.bind(this, action))
  }
}

export default AlignFloatAction
