const uploadImage = (file, settings, callback, localAttachImageId) => {
  const uploadUrl = settings.upload_url;

  const upload = (file, callback, imageId) => {
    const data = new FormData();
    data.append("files[]", file);

    if (!uploadUrl) {
      callback([{}]);
      return;
    }

    fetch(uploadUrl, {
      method: 'POST',
      body: data
    })
      .then(res => consume(res, callback, imageId))
      .catch(e => {
        console.error(e);
        alert("file upload 실패");
      });
  };

  const consume = (res, callback, imageId) => {
    const cloneRes = res.clone();
    const reader = res.body.getReader();
    let bytesReceived = 0;
    const processResult = result => {
      if (result.done) {
        console.log("Fetch complete");
        cloneRes.json().then(jsonData => {
          callback(imageId, jsonData);
        });
        return;
      }
      bytesReceived += result.value.length;
      console.log(`Received ${bytesReceived} bytes of data`);

      return reader.read().then(processResult);
    };
    reader.read().then(processResult);
  };

  upload(file, callback, localAttachImageId);
};

export default uploadImage;
