const attachLocalImage = (editor, file, settings) => {
  const getBlobData = file => {
    if (!file || !file.type) {
      return false
    }
    const blob = new Blob([file], { type: file.type })
    const blobUrl = URL.createObjectURL(blob)
    const blobUrlUrlArray = blobUrl
      .split('blob:')
      .join('')
      .split('/')
    const blobId = 'imageId' + blobUrlUrlArray[blobUrlUrlArray.length - 1]
    return { blobId, blobUrl }
  }

  const insertContent = elementString => {
    const $selectNode = editor.$(editor.selection.getNode())
    const $figureClosestNode = $selectNode.closest('figure, ul, ol, blockquote')
    if ($figureClosestNode.length > 0 && $selectNode.attr('data-ke-type') != 'image') {
      const newParagraph = editor.$('<p><br data-mce-bogus="1"></p>')[0]
      $figureClosestNode.after(newParagraph)
      editor.selection.setCursorLocation(newParagraph)
      editor.insertContent(elementString)
    } else {
      editor.insertContent(elementString)
    }
  }

  const attach = file => {
    const blobData: any = getBlobData(file)
    let imageElementString
    const imageElement = editor.dom.create('img', { id: blobData.blobId, src: blobData.blobUrl })
    imageElement.style.width = '100%'
    let attributeObj = { 'data-ke-type': 'image' }
    if (editor.settings.kImage.toolbar && editor.settings.kImage.toolbar.split('alignCenter').length > 1) {
      attributeObj['data-ke-style'] = 'alignCenter'
    }
    const wrapElement = editor.dom.create('figure', attributeObj)
    editor.dom.add(wrapElement, imageElement)
    imageElementString = wrapElement.outerHTML
    editor.undoManager.ignore(() => {
      insertContent(imageElementString)
    })
    return blobData.blobId
  }
  return attach(file)
}

export default attachLocalImage
