import photoApp from './photosApp'

const initPhotos = (editor, sucessCallback, editingImageId, photoEditCancelCallback) => {
  const photosInstance = photoApp(sucessCallback, photoEditCancelCallback)
  const photosContainer = photosInstance.frameEl.parentNode

  editor.addCommand('editImageForPhotosStart', () => {
    const $selectElement = editor.$(editor.selection.getNode())
    let $imageElement
    if ($selectElement[0].nodeName == 'FIGURE') {
      $imageElement = editor.$('img', $selectElement[0])
    } else if ($selectElement[0].nodeName == 'FIGCAPTION') {
      $imageElement = editor.$('img', $selectElement[0].parentNode)
    } else {
      $imageElement = $selectElement
    }
    $imageElement.attr('id', editingImageId)
    photosContainer.style.display = 'block'
    editor.dom.$('body').attr('contenteditable', false)
    photosInstance.open($imageElement[0].src)
    window.parent.focus()
  })

  editor.addCommand('editImageForPhotosEnd', () => {
    editor.dom.$('body').attr('contenteditable', true)
  })

  editor.addButton('kImageEdit', {
    title: 'Edit image',
    icon: 'imageedit',
    onclick() {
      editor.undoManager.ignore(() => {
        editor.execCommand('editImageForPhotosStart')
      })
    },
  })
}

export default initPhotos
