declare global {
  interface Window {
    photos: any
  }
}
const photosApp = (successCallback, cancelCallback) => {
  const options = {
    serviceName: 'kEditor',
    originType: 'daum', // default daum
    viewport: {
      list: 'fixed-width',
      preview: 'fixed-width',
    },
    shortCut: {
      cancel: 27, // esc keyCode
    },
    // menu: {
    //   main: [
    //     'filter',
    //     'crop',
    //     'size',
    //     'effect_all'
    //   ],
    //   sub: {
    //     effect: [
    //       'brightness',
    //       'contrast',
    //       'saturation',
    //       'warmth'
    //     ]
    //   }
    // },
    // filter: {
    //   type: 'flat',
    //   showTool: true,
    //   itemWidth: 60,
    //   itemHeight: 60,
    //   filterMargin: 20,
    //   filter: [
    //     {label: '원본', id: 'OR00'},
    //     {label: '01', id: 'AQ01'},
    //     {label: '02', id: 'AQ03'},
    //     {label: '03', id: 'AQ04'},
    //     {label: '04', id: 'AQ07'},
    //     {label: '05', id: 'AQ10'},
    //     {label: '06', id: 'BW03'},
    //     {label: '07', id: 'BW04'},
    //     {label: '08', id: 'BW06'},
    //     {label: '09', id: 'BW10'},
    //     {label: '10', id: 'CL01'},
    //     {label: '11', id: 'CL02'},
    //     {label: '12', id: 'CL03'},
    //     {label: '13', id: 'CL05'},
    //     {label: '14', id: 'CL06'},
    //     {label: '15', id: 'CL09'},
    //     {label: '16', id: 'RE01'},
    //     {label: '17', id: 'RE04'},
    //     {label: '18', id: 'RE05'},
    //     {label: '19', id: 'RE08'},
    //     {label: '20', id: 'RE09'},
    //     {label: '21', id: 'SO02'},
    //     {label: '22', id: 'SO07'},
    //     {label: '23', id: 'SO11'}
    //   ]
    // },
    // crop: {
    //   list: [
    //     {type: 'Free', label: '자유'},
    //     {type: 'number', width: 9, height: 16},
    //     {type: 'number', width: 3, height: 4},
    //     {type: 'number', width: 1, height: 1},
    //     {type: 'number', width: 4, height: 3},
    //     {type: 'number', width: 16, height: 9}
    //   ],
    //   ratioRotateMode: 'none'
    // },
    // resize: [
    //   {type: 'origin', label: '원본'},
    //   {type: 'w', size: '280'},
    //   {type: 'w', size: '350'},
    //   {type: 'w', size: '470'},
    //   {type: 'w', size: '700'},
    //   {type: 'w', size: '940'}
    // ],
    // modules: {
    //   'preview_draggable': false
    // }
  }

  const dataURItoBlob = dataURI => {
    let byteString = atob(dataURI.split(',')[1])

    let mimeString = dataURI
      .split(',')[0]
      .split(':')[1]
      .split(';')[0]

    let ab = new ArrayBuffer(byteString.length)
    let ia = new Uint8Array(ab)
    for (let i = 0; i < byteString.length; i++) {
      ia[i] = byteString.charCodeAt(i)
    }

    return new Blob([ab], { type: mimeString })
  }

  function createApp(): any {
    const containerStr = '<div class="kEditor_photos_container" style="position:fixed;top: 0;right:0;bottom:0;left:0;z-index:99999;display:none;"></div>'
    const warpElement: HTMLDivElement = document.createElement('div')
    warpElement.innerHTML = containerStr
    const photosContainer: Node = warpElement.firstChild
    document.body.appendChild(photosContainer)
  
    const app = new window.photos.App(photosContainer, options)
  
    app.on('photos:edit:complete', resultArr => {
      window.keditorPhotos.onSuccess(resultArr, dataURItoBlob(resultArr[0].dataURL))
      photosContainer['style'].display = 'none'
    })
  
    app.on('photos:edit:cancel', () => {
      window.keditorPhotos.onCancel()
      photosContainer['style'].display = 'none'
    })

    return app;
  }




  if (!window.keditorPhotos) {
    window.keditorPhotos = {
      app: createApp(),
      onSuccess: successCallback,
      onCancel: cancelCallback
    }
  } else {
    window.keditorPhotos.onSuccess = successCallback;
    window.keditorPhotos.onCancel = cancelCallback;
  }

  return window.keditorPhotos.app
}

export default photosApp
