const register = (editor, name) => {
  const getImageFigure = element => {
    const $figureNode = editor.$(element).closest('figure[data-ke-type="image"]')
    if ($figureNode && $figureNode[0]) {
      return $figureNode
    } else {
      return null
    }
  }

  // 이상하게 onpostrender 이벤트에는 arrowFunction으로 지정하면 this를 받아 오지 못함
  const postrender = function(e) {
    const control = this
    let $figureNode, keStyle, textAlignValue, state
    $figureNode = getImageFigure(editor.selection.getNode())

    const toggleActive = $figureNode => {
      keStyle = $figureNode.attr('data-ke-style')
      control.active(control.settings.activestate == keStyle)
    }

    if ($figureNode) {
      toggleActive($figureNode)
    }

    editor.on('nodechange', e => {
      const selectNode = editor.selection.getNode()
      $figureNode = getImageFigure(selectNode)
      if ($figureNode) {
        toggleActive($figureNode)
      }
    })
  }

  if (name === 'alignLeft') {
    editor.addButton('kImageAlignLeft', {
      title: 'Align left',
      cmd: 'kImageAlignLeft',
      icon: 'imagealignleft',
      activestate: name,
      onpostrender: postrender,
    })
  } else if (name === 'alignCenter') {
    editor.addButton('kImageAlignCenter', {
      title: 'Align center',
      cmd: 'kImageAlignCenter',
      icon: 'imagealigncenter',
      activestate: name,
      onpostrender: postrender,
    })
  } else if (name === 'alignRight') {
    editor.addButton('kImageAlignRight', {
      title: 'Align right',
      cmd: 'kImageAlignRight',
      icon: 'imagealignright',
      activestate: name,
      onpostrender: postrender,
    })
  } else if (name === 'floatLeft') {
    editor.addButton('kImageFloatLeft', {
      title: 'Align left',
      cmd: 'kImageFloatLeft',
      icon: 'imagefloatleft',
      activestate: name,
      onpostrender: postrender,
    })
  } else if (name === 'floatRight') {
    editor.addButton('kImageFloatRight', {
      title: 'Align right',
      cmd: 'kImageFloatRight',
      icon: 'imagefloatright',
      activestate: name,
      onpostrender: postrender,
    })
  }
}

export default {
  register,
}
