import ResizePanel from '../action/ResizePanelAction'

const register = editor => {
  const getImageFigure = element => {
    const $figureNode = editor.$(element).closest('figure[data-ke-type="image"]')
    if ($figureNode && $figureNode[0]) {
      return $figureNode
    } else {
      return null
    }
  }

  const postrender = function() {
    const control = this
    let $figureNode: any
    $figureNode = editor.selection.getNode()

    editor.on('change', () => {
      const selectNode = editor.selection.getNode()
      $figureNode = getImageFigure(selectNode)
    })
  }

  const panel = new ResizePanel(editor, 'kImageResizeWidthInput')

  editor.addButton('kImageResize', {
    title: 'Resize Image',
    tooltip: 'Resize Image',
    icon: 'resizeimage',
    type: 'panelbutton',
    onpostrender: postrender,
    panel: {
      classes: 'kImageResize tinymce',
      role: 'dialog',
      fixed: false,
      onPostRender() {
        panel.init(this)
      },
      items: [
        { type: 'label', classes: 'widthLabel', text: 'W' },
        {
          type: 'textbox',
          id: 'kImageResizeWidthInput',
          classes: 'kImageWidthInput',
          size: 3,
          maxLength: 3,
          label: 'Width',
          name: 'width',
          onsubmit: function() {
            panel.updateImageWidth(this.value())
            this.parent().hide()
          },
        },
        {
          type: 'button',
          classes: 'kImageMaxSize',
          title: 'Resize Image Max size',
          icon: 'reiszeimagemax',
          tooltip: 'Max Size',
          onclick: panel.updateMaxSize.bind(panel),
        },
      ],
    },
    onshow(e: any) {
      e.control.fixed(false)
      panel.show()
    },
    onhide() {
      editor.focus()
    },
  })

  editor.on('ObjectResized', function(e) {
    if (e.target.nodeName == 'IMG') {
      panel.updateImageWidth(e.target.getAttribute('width'))
    }
  })
}

export default {
  register,
}
