import Tools from 'tinymce/core/api/util/Tools';

const styleValueToText = function (styleValue) {
  return styleValue.replace(/\-/g, ' ').replace(/\b\w/g, function (chr) {
    return chr.toUpperCase();
  });
};

const toMenuItems = function (styles) {
  return Tools.map(styles, function (data) {
    const text = styleValueToText(data.style);
    const style = data.style === 'default' ? '' : data.style;
    const nodeType = data.type;
    const icon = data.icon
    const classes = 'kList'

    return { text, style, nodeType, icon, classes };
  });
};

export default {
  toMenuItems
};
