import Panel from './ui/panel'
import MoreLess from './MoreLess';

const plugin = (editor) => {

  const generatePanelHtml = () => {
    let html = `<div class="keditor-moreless-panel" style="width: 140px;">
      <form class='keditor-form moreless-form'>
        <div class="body">
          <label class="form-field">
            <span class="form-label">열기 문구</span>
            <input name="open" type="text" class="form-text moreless-more" placeholder="열기 문구" />
          </label>
          <label class="form-field">
            <span class="form-label">닫기 문구</span>
            <input name="close" type="text" class="form-text moreless-less" placeholder="닫기 문구" />
          </label>
        </div>
        <div class="footer">
          <button type="submit" class="btn btn-default">확인</button>
          <button type="cancel" class="btn btn-unlink">취소</button>
        </div>
      </form>
    </div>`
  
    return html;
  }

  const panel = new Panel(editor)

  editor.addButton('moreLess', {
    icon: 'moreLess',
    type: 'panelbutton',
    tooltip: 'moreLess',
    stateSelector: 'figure[data-ke-type="moreLess"]',
    // disabledStateSelector: 'img,iframe,div',
    panel: {
      role: 'dialog',
      html: generatePanelHtml(),
      onPostRender() {
        panel.init(this)
        this.fixed(true)
      }
    },
    onshow() {
      panel.show()
    },
    onhide() {
      editor.focus();
    },
  })

  const moreLess = new MoreLess(editor);

  editor.addCommand('cmdMoreLess', () => {
    moreLess.apply()
  });

}

export default plugin
