import MoreLess from '../MoreLess';

class Panel {
  editor: any;
  moreLess: MoreLess;
  panel: any;
  openTextInput: HTMLInputElement;
  closeTextInput: HTMLInputElement;

  constructor(editor) {
    this.editor = editor
    this.moreLess = new MoreLess(editor);
  }

  init(panel) {
    this.panel = panel
    const panelNode = panel.$el[0]
    const $ = this.editor.$
    this.addEvent(panelNode)
    this.openTextInput = $('input[name="open"]', panelNode)[0]
    this.closeTextInput = $('input[name="close"]', panelNode)[0]
  }

  addEvent(panelNode) {
    const $ = this.editor.$
    $('button[type="submit"]', panelNode).on('click', this.onSubmit.bind(this))
    $('button[type="cancel"]', panelNode).on('click', this.onCancel.bind(this))
  }

  show() {
    this.openTextInput.focus()
    this.openTextInput.value = '더보기'
    this.closeTextInput.value = '닫기'
  }

  onSubmit(e) {
  	e.preventDefault()
    this.panel.hide();
    this.moreLess.apply(this.openTextInput.value, this.closeTextInput.value);
	}

	onCancel(e) {
		this.panel.hide();
  }
}

export default Panel;
