const getAnchor = rng => {
  const node = rng.startContainer;
  const offset = rng.startOffset;

  let targetNode;
  
  if(node.nodeName === 'A') {
    targetNode = node;
  }

  if(node.nodeName !== '#text') {
    const curNode = offset === node.childNodes.length ? node.lastChild : node.childNodes[offset];


    if(!curNode) {
      return;
    }

    if(curNode.nodeName === 'A') {
      targetNode = curNode;
    }
    else if(curNode.previousSibling && curNode.previousSibling.nodeName === 'A') {
      targetNode = curNode.previousSibling;
    }
    else if(curNode.previousSibling && curNode.previousSibling.previousSibling && curNode.previousSibling.previousSibling.nodeName === 'A') {
      targetNode = curNode.previousSibling.previousSibling;
    }
  }
  else {
    if(node.parentNode.nodeName === 'A') {
      targetNode = node.parentNode;
    }
    if(node.textContent.length === 1 && node.textContent[0].search(/[\s]/) > -1 && node.previousSibling && node.previousSibling.nodeName === 'A') {
      targetNode = node.previousSibling;
    }
  }
  return targetNode;
}

export default getAnchor;