const render = (res, figure) => {
  figure.id = `og_${Date.now()}`
  let htmlString

  if (res.type.startsWith('video')) {
    let host
    switch (res.host) {
      case 'tv.kakao.com':
        host = 'kakaotv'
        break
      case 'vimeo.com':
        host = 'vimeo'
        break
      case 'www.youtube.com':
        host = 'youtube'
        break
    }

    figure.setAttribute('data-ke-type', 'video')
    figure.setAttribute('data-ke-style', 'alignCenter')
    figure.setAttribute('data-video-host', host)
    figure.setAttribute('data-video-url', res.url)
    figure.setAttribute('data-video-thumbnail', res.image)
    figure.setAttribute('data-original-url', res['original_url'])

    htmlString = `<img src="${res.image}"></img><span><br></span>`
  } else {
    figure.setAttribute('data-ke-type', 'opengraph')
    htmlString = ` 
      <a href="${res.url}" target="_blank" data-original-url="${res.original_url}">
        <div class="og-image" style="background-image:url(${res.image})"></div>
        <div class="og-text">
          <p class="og-title">${res.title}</p>
          <p class="og-desc">${res.description}</p>
          <p class="og-host">${res.host}</p>
        </div>
      </a>
    `
  }
  return htmlString
}

export default render
