import { makeOpengraph, makeOpengraphWithUrl } from './components/makeOpengraph'
import getAnchor from './components/getAnchor'

const plugin = editor => {
  const makeCallback = () => {
    const rng = editor.selection.getSel().getRangeAt(0)
    const targetNode = getAnchor(rng)
    makeOpengraph(editor, targetNode, rng)
  }

  function cmdMakeOpengraph(url: string) {
    makeOpengraphWithUrl(editor, url)
  }

  editor.addCommand('makeOpengraph', makeCallback)
  editor.addCommand('makeOpengraphWithUrl', cmdMakeOpengraph)

  editor.on('keyDown', e => {
    if (e.keyCode === 13) {
      const rng = editor.selection.getSel().getRangeAt(0)
      const targetNode = getAnchor(rng)
      if (targetNode) {
        e.preventDefault()
        makeOpengraph(editor, targetNode, rng)
      }
    }
  })
}

export default plugin
