// item.type의 값에 따라 어떤 방식으로 처리될 것인지 결정한다.
// 만약 clipboardData.items가 여러개일 경우, html을 1순위, plainText를 2순위, image를 3순위로 처리한다.
// 특히 ms word 내용을 붙여넣기 할 경우 html, plainText, image 등등이 한번에 들어오게 되는데, 이런 경우를 막기 위함.
const decideProcess = items => {
  const returnee: {[key: string]: any} = {};
  
  for(let item of items) {
    if(item.type.indexOf('html') >= 0) {
      returnee.htmlItem = item;
    }
    else if(item.type.indexOf('plain') >= 0) {
      returnee.plainTextItem = item;
    }
    else if(item.type.indexOf('image') >= 0) {
      returnee.imageItem = item;
    }
  }

  return returnee;
}

export default decideProcess;