import unescapeHtml from './unescapeHtml';

const handleIEPaste = (e, editor, callback) => {

  const makeAfterPaste = rng => {
    return () => {
      const iePastebin = editor.dom.get('ie_pastebin');
      const htmlString = iePastebin.innerHTML;
      iePastebin.innerHTML = htmlString;
      const items: {[key: string]: any} = {}

      if(iePastebin.childNodes.length === 1 && iePastebin.childNodes[0].nodeName === '#text') {
        items.plainTextItem = iePastebin.childNodes[0].textContent;
      }
      else {
        items.htmlItem = unescapeHtml(iePastebin.innerHTML);
      }
      
      editor.focus();
      editor.getBody().removeChild(iePastebin);
      editor.selection.setRng(rng);
      callback(items);
      return true;
    }
  }

  const rng = editor.selection.getSel().getRangeAt(0).cloneRange();
  const dom = editor.dom;
  const body = editor.getBody();
  const iePastebin = document.createElement('div');
  const afterPaste = makeAfterPaste(rng);
  iePastebin.id = 'ie_pastebin';
  iePastebin.setAttribute('style', 'position: fixed; top: 50%; width: 100px; height: 100px; overflow: hidden; ');
  iePastebin.setAttribute('contenteditable', 'true');
  body.appendChild(iePastebin);

  dom.setStyle(iePastebin, 'left', dom.getStyle(body, 'direction', true) === 'rtl' ? 0xFFFF : -0xFFFF);
  iePastebin.focus();
  setTimeout(afterPaste, 0);
}

export default handleIEPaste;