const handleImage = (editor, item, deleteRange) => {

  editor.windowManager.open({
    width: 800,
    height: 100,
    classes: 'white-dialog',
    items: [{
      type: 'container',
      html: `<div class='mce-white-body'><p class='mce-white-message'>붙여넣기 및 이미지 업로드 중입니다</p><div class='mce-white-progress-border'><div class='mce-white-progress-percentage'></div></div><p class='mce-white-percentage-number'>0%</p></div>`
    }],
    buttons: [],
  });

  const imageFile = item.getAsFile();
  editor.undoManager.ignore(() => {
    editor.execCommand('KImageUploadFile', {
      file: imageFile,
      requireDom: true,
      callback: result => {
        if(deleteRange) deleteRange();
        editor.insertContent(result.dom.outerHTML, {paste: "kPaste"});
        imageUploadCallback();
        editor.nodeChanged();
      }
    })
  });

  const imageUploadCallback = () => {
    
    const bar = <HTMLElement>document.getElementsByClassName('mce-white-progress-percentage')[0];
    const percentText = document.getElementsByClassName('mce-white-percentage-number')[0];
    const percent = 100;

    bar.style.width = percent + '%';
    percentText.textContent = Math.round(percent) + '%';

    editor.windowManager.close();
  }
}

export default handleImage;