import getImmediateHandler from './getImmediateHandler';

const handlePlainText = (editor, plainTextItem, targetNode, deleteRange) => {

  const handleImmediately = getImmediateHandler(editor.selection.getNode());
  if(handleImmediately) {
    const p = document.createElement('p');  
    p.textContent = plainTextItem;
    if(deleteRange) {
      deleteRange();
    }
    handleImmediately(editor, p);
    editor.dom.remove(p);
    return;
  }

  let res = plainTextItem;
  // 텍스트 내용 중 \n은 <br>로, url 형태의 텍스트는 <a>를 입히고, 여러개의 스페이스륿 보존하기 위해 정규식으로 replace.
  res = res.replace(/\n/gi, '<br>');
  res = res.replace(/((https?:\/\/)?[www\.]?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b[-a-zA-Z0-9@:%_\+.~#?&\/\/=\(\)\[\]!$'*,;]*)/gi, '<a href="$1" target="_blank">$1</a>');
  res = res.replace(/ /gi, '\u00A0');

  editor.insertContent(res, {paste: "kPaste"});
  editor.nodeChanged();
}

const getAsPromise = str => new Promise(resolve => {
  str.getAsString(item => {
    resolve(item);
  })
})

const extractPlainText = async item => {
  let returnee;
  if(item.getAsString) {
    returnee = await getAsPromise(item);
  } 
  else if(typeof item !== 'string') {
    returnee = item.data;
  } 
  else {
    returnee = item;
  }
  return returnee;
}

export {
  handlePlainText,
  extractPlainText,
}