const register = editor => {
  const preventFormatNodes: String[] = ['FIGURE', 'FIGCAPTION', 'PRE', 'DIV']
  const preventCommend: String[] = ['mceApplyTextcolor', 'mceToggleFormat']
  editor.on('BeforeExecCommand', e => {
    if (preventCommend.includes(e.command)) {
      const selectionNode = editor.selection.getNode()
      if (preventFormatNodes.includes(selectionNode.nodeName)) {
        return false
      }
    }
  })
}

export default {
  register,
}
