const register = editor => {
  let keSelectedElement: Element
  const blockItemTagArray = ['FIGURE', 'HR']

  const setSelectionAttribute = e => {
    if (!e.selectionChange) {
      let selectionNode: Element = e.element
      selectionNode = blockItemTagArray.includes(selectionNode.parentElement.nodeName)
        ? selectionNode.parentElement
        : selectionNode
      let $selectionNode = editor.$(selectionNode)
      removeSelection(selectionNode)
      if (blockItemTagArray.includes(selectionNode.nodeName)) {
        selectionNode.setAttribute('data-mce-selected', 'ke')
        keSelectedElement = selectionNode
      } else if (selectionNode.tagName == 'P' && $selectionNode.attr('data-mce-caret')) {
        if (
          $selectionNode.attr('data-mce-caret') == 'after' &&
          blockItemTagArray.includes($selectionNode.prev()[0].tagName)
        ) {
          keSelectedElement = $selectionNode.prev()[0]
          editor.selection.select(keSelectedElement)
          $selectionNode.prev().attr('data-mce-selected', 'ke')
        } else if (
          $selectionNode.attr('data-mce-caret') == 'before' &&
          blockItemTagArray.includes($selectionNode.next()[0].tagName)
        ) {
          keSelectedElement = $selectionNode.next()[0]
          $selectionNode.next().attr('data-mce-selected', 'ke')
        }
      }
    }
  }

  const removeSelection = (targetNode: Element) => {
    keSelectedElement && keSelectedElement != targetNode && keSelectedElement.removeAttribute('data-mce-selected')
  }

  editor.on('nodeChange', setSelectionAttribute)

  editor.on('blur', e => {
    window.setTimeout(() => {
      editor.dom.$('[data-mce-selected]').removeAttr('data-mce-selected')
      editor.dom.$('.mce-resizehandle').remove()
    })
  })
}

export default {
  register,
}
