import ListBox from 'tinymce/ui/ListBox'
import MenuBar from 'tinymce/ui/MenuBar'

export default ListBox.extend({
  renderHtml () {
    const self = this, id = self._id, prefix = self.classPrefix;
    let icon = self.settings.icon, image;
    const text = self.state.get('text');
    let textHtml = '';

    image = self.settings.image;
    if (image) {
      icon = 'none';

      // Support for [high dpi, low dpi] image sources
      if (typeof image !== 'string') {
        image = window.getSelection ? image[0] : image[1];
      }

      image = ' style="background-image: url(\'' + image + '\')"';
    } else {
      image = '';
    }

    if (text) {
      self.classes.add('btn-has-text');
      textHtml = '<span class="' + prefix + 'txt">' + self.encode(text) + '</span>';
    }

    icon = self.settings.icon ? prefix + 'ico ' + prefix + 'i-' + icon : '';

    self.aria('role', self.parent() instanceof MenuBar ? 'menuitem' : 'button');

    return (
      '<div id="' + id + '" class="' + self.classes + '" tabindex="-1" aria-labelledby="' + id + '">' +
      '<button id="' + id + '-open" role="presentation" type="button" tabindex="-1">' +
      (icon ? '<i class="' + icon + '"' + image + '></i>' : '') +
      textHtml +
      '</button>' +
      '</div>'
    );
  }
})
