const register = editor => {
  editor.on('click', e => {
    const target = e.target
    if (target.tagName == 'BODY') {
      insertEmptyParagraphProcess(e)
    }
  })

  const getBottomElementByClickOffsetY = clickOffsetY => {
    const $figureElem = editor.dom.$('figure')
    for (let i = 0, l = $figureElem.length; i < l; i++) {
      if ($figureElem[i].offsetTop > clickOffsetY) {
        return $figureElem[i]
      }
    }
  }

  const insertEmptyParagraphProcess = e => {
    const $clickBottomFigrueElem = editor.$(getBottomElementByClickOffsetY(e.offsetY))
    if ($clickBottomFigrueElem[0]) {
      const $previousElemFromFirgureElem = $clickBottomFigrueElem.prev()
      if ($previousElemFromFirgureElem[0] && $previousElemFromFirgureElem[0].tagName == 'FIGURE' &&
      $previousElemFromFirgureElem[0].offsetTop + $previousElemFromFirgureElem[0].offsetHeight < e.offsetY) {
        insertEmptyParagraph($previousElemFromFirgureElem, 'after')
      } else if (!$previousElemFromFirgureElem[0]) {
        insertEmptyParagraph($clickBottomFigrueElem, 'before')
      }
    } else if (e.target.lastChild.tagName == 'FIGURE') {
      if (e.target.lastChild.offsetTop + e.target.lastChild.offsetHeight < e.offsetY) {
        insertEmptyParagraph(e.target.lastChild, 'after')
      }
    }
  }

  const insertEmptyParagraph = (elem, beforeAfter) => {
    const $elem = editor.$(elem)
    const newParagraph = editor.$('<p><br></p>')[0]
    if (beforeAfter == 'before') {
      $elem.before(newParagraph)
    } else if (beforeAfter == 'after') {
      $elem.after(newParagraph)
    }
    editor.selection.setCursorLocation(newParagraph)
    setCursorLocationFirst(newParagraph)
    editor.undoManager.add()
  }

  const setCursorLocationFirst = targetElement => {
    const range = editor.selection.getRng()
    range.setStart(targetElement, 0)
    range.setEnd(targetElement, 0)
    editor.selection.getSel().addRange(range);
  }
}

export default {
  register
}