class NodeChangedSelector {
  constructor(editor) {
    this.editor = editor
    this.keSelectedElement = null
    this.init()
  }

  init() {
    this.addNodeChangeEvent()
  }

  addNodeChangeEvent() {
    this.editor.on('nodeChange', this.setSelectionAttribute.bind(this));
  }

  setSelectionAttribute(e) {
    if (!e.selectionChange) return false
    let selectionNode = e.element
    selectionNode = selectionNode.parentNode.tagName == 'FIGURE' ? selectionNode.parentNode : selectionNode
    let $selectionNode = this.editor.$(selectionNode)
    this.removeSelection(selectionNode)
    if (selectionNode.tagName == 'FIGURE') {
      selectionNode.setAttribute('data-mce-selected', 'ke')
      this.keSelectedElement = selectionNode
    } else if (selectionNode.tagName == 'P' && $selectionNode.attr('data-mce-caret')) {
      if ($selectionNode.attr('data-mce-caret') == 'after' && $selectionNode.prev()[0].tagName == 'FIGURE') {
        this.keSelectedElement = $selectionNode.prev()[0]
        this.editor.selection.select(this.keSelectedElement)
        $selectionNode.prev().attr('data-mce-selected', 'ke')
      } else if ($selectionNode.attr('data-mce-caret') == 'before' && $selectionNode.next()[0].tagName == 'FIGURE') {
        this.keSelectedElement =  $selectionNode.next()[0]
        this.editor.selection.select(this.keSelectedElement)
        $selectionNode.next().attr('data-mce-selected', 'ke')
      }
    }
  }

  removeSelection(targetNode) {
    this.keSelectedElement && this.keSelectedElement != targetNode && this.keSelectedElement.removeAttribute('data-mce-selected')
  }
}

export default NodeChangedSelector