import { Behaviour, Button, Container, Memento, Toggling, SketchSpec } from '@ephox/alloy';
import { Throttler } from '@ephox/katamari';

import Styles from '../../style/Styles';
import * as UiDomFactory from '../../util/UiDomFactory';

const sketch = function (onView, translate): SketchSpec {

  const memIcon = Memento.record(
    Container.sketch({
      dom: UiDomFactory.dom('<div aria-hidden="true" class="${prefix}-mask-tap-icon"></div>'),
      containerBehaviours: Behaviour.derive([
        Toggling.config({
          toggleClass: Styles.resolve('mask-tap-icon-selected'),
          toggleOnExecute: false
        })
      ])
    })
  );
  // 모바일 태마로 바로 전환 2018.07.12
  // TODO 바로 모바일 테마로 로딩 하는 방법도 찾아야함
  const onViewThrottle = Throttler.first(onView, 0);
  onViewThrottle.throttle()
  return Container.sketch({
    dom: UiDomFactory.dom('<div class="${prefix}-disabled-mask"></div>'),
    components: [
      Container.sketch({
        dom: UiDomFactory.dom('<div class="${prefix}-content-container"></div>'),
        components: [
          Button.sketch({
            dom: UiDomFactory.dom('<div class="${prefix}-content-tap-section"></div>'),
            components: [
              memIcon.asSpec()
            ],
            action (button) {
              onViewThrottle.throttle();
            },

            buttonBehaviours: Behaviour.derive([
              Toggling.config({
                toggleClass: Styles.resolve('mask-tap-icon-selected')
              })
            ])
          })
        ]
      })
    ]
  });
};

export default {
  sketch
};