import * as ToolbarWidgets from 'tinymce/themes/mobileClassic/main/ts/ui/ToolbarWidgets';
import * as UiDomFactory from 'tinymce/themes/mobileClassic/main/ts/util/UiDomFactory';
import { Container, Button } from '@ephox/alloy';
import Styles from '../style/Styles';

const sketch = (realm, editor, formats) => () => ToolbarWidgets.button(realm, 'style-headings', () => makeItems(formats), 3, realm.closeFourthToolbar);

const makeItems = (formats) => [makeContainer(formats)];

const makeContainer = (formats: {Number: Function}) => {
  const components = [];
  Object.values(formats).forEach(format => {
    components.push(format());
  });

  return Container.sketch({
    dom: {
      classes: [ Styles.resolve('font-heading-container') ],
    },
    components,
  })
}

export {
  sketch,
};