import * as ToolbarWidgets from 'tinymce/themes/mobileClassic/main/ts/ui/ToolbarWidgets';
import { Container, Button } from '@ephox/alloy';
import Styles from '../style/Styles';

const sketch = (realm, editor, sketchList) => () => ToolbarWidgets.button(realm, 'style-formats', () => makeItems(realm, sketchList), 3);

const makeItems = (realm, sketchList) => [makeContainer(realm, sketchList)];

const makeContainer = (realm, sketchList) => {
  const components = [];
  sketchList.forEach(spec => {
    const sketch = spec(realm);
    components.push(typeof sketch === 'function' ? sketch() : sketch);
  })
  return Container.sketch({
    dom: {
      classes: [ Styles.resolve('font-style-container') ]
    },
    components,
  })
}

export {
  sketch,
};