import Buttons from './Buttons';
import { SketchSpec, Behaviour, Receiving, Toggling } from '@ephox/alloy';
import Receivers from '../channels/Receivers';
import TinyChannels from '../channels/TinyChannels';
import Styles from '../style/Styles';

declare let window: any;

const button = function (realm, clazz, makeItems, target?, extraAction?): SketchSpec {
  return Buttons.forToolbar(clazz, function () {

    realm.system().broadcastOn([ TinyChannels.menuTouched() ], {
      origin: clazz,
    });

    if(extraAction) {
      extraAction(realm);
    }

    const items = makeItems();
    realm.setContextToolbar([
      {
        // FIX: I18n
        label: clazz + ' group',
        items
      }
    ], target);
  }, 
  Behaviour.derive([
    Toggling.config({
      toggleClass: Styles.resolve('icon-selected'),
      toggleOnExecute: true,
    }),
    Receivers.menuTouched((button, data) => {
      const origin = data.origin;
      const name = button.spec().dom.attributes['data-ke-btn-name'];

      if(!(origin === 'color' && name === 'style-formats')) {
        Toggling.off(button);
      }
    })
  ]));
};

export {
  button
};